<template>
  <frame :modal="modal" dimmed>
    <form @submit.prevent="save()" class="p-4 flex flex-col items-start">
      <label for="wait_for" class="block text-sm font-medium text-gray-700">Wait for</label>
      <input
        type="text"
        id="wait_for"
        class="mt-1 focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm border border-gray-300 rounded-md p-2"
        v-model="task.waitingFor"
        ref="waitingForInput"
      />
      <label for="wait_until" class="block text-sm font-medium text-gray-700 mt-4">Wait until</label>
      <div
        @click="modals.show('date-picker')"
        class="mt-1 focus:ring-indigo-500 focus:border-indigo-500 flex flex-row items-center w-full shadow-sm sm:text-sm border border-gray-300 rounded-md p-2"
      >
        <i class="hero solid calendar text-gray-500 mr-2"></i>
        <div v-if="task.postponedUntil" class="flex-1">
          {{ task.postponedUntil.toLocaleString({ weekday: "short", month: "short", day: "2-digit" }) }}
        </div>
        <div v-else class="text-gray-700">Choose a date (optional)...</div>
        <i
          v-if="task.postponedUntil"
          @click.stop="task.postponedUntil = null"
          class="hero solid x text-gray-500 ml-2"
        ></i>
      </div>
      <button type="submit" class="button bg-green-500 inline-flex flex-row items-center mt-4 self-end">
        <i class="hero solid check mr-2"></i>
        Save
      </button>
    </form>
    <modal
      :is="modals.get('date-picker')"
      title="Wait until"
      @input="input($event)"
      :value="task.postponedUntil"
    />
  </frame>
</template>

<script lang="ts">
import DatePicker from "@/components/DatePicker.vue";
import { isModal, useModals } from "@/use/modal";
import Task from "@/models/Task";
import { nextTick, onMounted, ref, watch } from "@vue/runtime-core";

export default {
  components: { DatePicker },
  mixins: [isModal()],
  emits: ["picked"],
  props: {
    task: {
      type: Task,
      required: true
    }
  },
  setup(props) {
    const task = props.task.id ? Task.findSync(props.task.id)! : props.task;
    const waitingForInput = ref<HTMLElement | null>(null);
    watch(
      () => props.modal.state.show,
      show => {
        if (show) {
          nextTick(() => waitingForInput.value?.focus());
        }
      }
    );
    return {
      waitingForInput,
      save: async () => {
        props.modal.hide();
        await task.save();
      },
      input: (e) => {
          task.$setAttribute('postponedUntil', e)
      },
      modals: useModals({ DatePicker }),
      task
    };
  }
};
</script>
